%Mecatrnica. Control y Automatizacin. 2013
%Fernando Reyes Corts, Jaime Cid Monjaraz y Emilio Vargas Soto
%Alfaomega  "Te acerca al conocimiento"


clc;
clear; 
close all; 
format short g

%parmetros de simulacin:
ti=0; h=0.0025; tf = 10; %tiempo de simulacin 0 a 10 segundos 
ts=ti:h:tf; %vector tiempo
%configuracin de la funcin ode45
opciones=odeset('RelTol',1e-06,'InitialStep', h, 'MaxStep', h);
ci=[0; 0; 0; 0; 0; 0]; %condiciones iniciales
%solucin numrica del sistema, con condicin iniciales cero
[t,x]=ode45('robot3gdl',ts,ci, opciones);


    q1=x(:,1);    q2=x(:,2); q3=x(:,3);
    qp1=x(:,4);   qp2=x(:,5);  qp3=x(:,6);
    
   [n,m]=size(t);
   tau1=zeros(n,1);   tau2=zeros(n,1); tau3=zeros(n,1); 
qtilde1=zeros(n,1); qtilde2=zeros(n,1); qtilde3=zeros(n,1);
   for k=1:n   
    [tau, qtilde] = saturado3gdl([q1(k);q2(k); q3(k)], [qp1(k); qp2(k);qp3(k)]);
    tau1(k)=tau(1); tau2(k)=tau(2); tau3(k)=tau(3);
    qtilde1(k)=qtilde(1); qtilde2(k)=qtilde(2); qtilde3(k)=qtilde(3);
   end

%grficas de las 3 articulaciones; $q_1$=x(:,1), $q_2=$x(:,2), $q_3=$x(:,3) 
subplot(3,1,1); plot( t, 180*q1/pi, t,180*q2/pi, t,180*q3/pi)
subplot(3,1,2); plot(t, 180*qtilde1/pi, t, 180*qtilde2/pi,  t, 180*qtilde3/pi)
subplot(3,1,3); plot( t, tau1, t,tau2, t, tau3)


